#include "DigitalInputPin.h"

DigitalInputPin::DigitalInputPin(uint8_t _pin, long _debounceDelay) {
  pin = _pin;
  debounceDelay = _debounceDelay;
  debounceMillis = 0;
  pinMode(pin, INPUT);
  oldState = digitalRead(pin);
}

int DigitalInputPin::fallingEdge() {
  int state = digitalRead(pin);
  int ret = 0;
  if (state == 0 && oldState == 1 && millis() - debounceMillis > debounceDelay) {
     ret = 1;
     debounceMillis = millis();
  }
  oldState = state;
  return ret;
}

int DigitalInputPin::raisingEdge() {
  int state = digitalRead(pin);
  int ret = 0;
  if (state == 1 && oldState == 0 && millis() - debounceMillis > debounceDelay) {
     ret = 1;
     debounceMillis = millis();
  }
  oldState = state;
  return ret;
}


